import { J as Json, O as ObjectStorage, L as LogHandlerOptions, dE as LogMessage, a as LogHandler, b as LogLevelAliasType, c as LoggerInterface } from './uuid-7feee97a.js';
export { ee as ArgumentsType, c_ as AsyncMutex, di as AsyncReturnType, aa as BinInput, B as BinaryEncoder, n as CRYPTO_DEFAULT_ALG, o as CRYPTO_DEFAULT_DERIVE_ALG, p as CRYPTO_DEFAULT_DERIVE_ITERATIONS, C as CRYPTO_DEFAULT_HASH_ALG, dQ as Channel, dP as ChannelMessageEvent, e1 as CryptoEncoder, aP as DAY_MS, bc as Day, aR as DayInput, bb as DayInputLegacy, aQ as DayValue, bi as DecimalInput, bh as DecimalValue, dW as DefaultListener, dt as DefaultLogger, br as Difference, bq as DifferenceType, cU as Disposer, cT as DisposerFunction, dX as Emitter, dU as EmitterAllHandler, dT as EmitterHandler, d_ as Encoder, bR as FilterFunction, e0 as JsonEncoder, dV as ListenerSignature, dR as LocalChannel, du as LogLevel, dC as LogLevelAlias, dD as LogLevelAliasKey, dv as LogLevelAll, dw as LogLevelDebug, dz as LogLevelError, dA as LogLevelFatal, dx as LogLevelInfo, dB as LogLevelOff, dy as LogLevelWarn, dH as LoggerConsoleHandler, dI as LoggerContext, dF as LoggerContextInterface, dO as LoggerMemoryHandler, bS as MapperFunction, eC as MemStorage, eB as MemStorageOptions, e4 as Message, e2 as MessageAction, e8 as MessageDefinitions, e9 as MessageHub, e3 as MessageResult, e6 as MessagesDefaultMethods, e7 as MessagesMethods, e5 as MessagesOptions, cZ as Mutex, eI as NestedArray, d$ as NoopEncoder, d2 as PoolConfig, d5 as PoolTask, d6 as PoolTaskEvents, d3 as PoolTaskFn, d1 as PoolTaskIdConflictResolution, d4 as PoolTaskState, bv as Primitive, d8 as Progress, ec as PubSub, ei as RPCFn, eh as RPCOptions, eg as RPCOptionsBasic, ej as RPCReturn, aG as RenderMessagesOptions, ef as ReturnType, cf as RoundingMode, dl as SerialQueue, cq as SortableItem, dk as TaskEvents, dj as TaskFn, aO as Uint8ArrayToDataUri, aq as Uint8ArrayToHexDump, ap as Uint8ArrayToJson, ae as Uint8ArrayToString, cS as UseDefer, cQ as UseDispose, em as UseRPCHubType, cN as XRX, ac as _decodeUtf8Polyfill, ab as _encodeUtf8Polyfill, $ as _useBase, Y as arrayAvg, Z as arrayBatches, M as arrayEmptyInPlace, I as arrayFilterInPlace, D as arrayFlatten, E as arrayIntersection, Q as arrayIsEqual, V as arrayMax, W as arrayMin, z as arrayMinus, U as arrayRandomElement, G as arrayRemoveElement, H as arraySetElement, S as arrayShuffle, T as arrayShuffleForce, R as arrayShuffleInPlace, N as arraySorted, P as arraySortedNumbers, X as arraySum, F as arraySymmetricDifference, K as arrayToggleInPlace, A as arrayUnion, y as arrayUnique, d as assert, e as assertCondition, c2 as avg, c0 as between, k as bitfield, l as blobToArrayBuffer, aN as blobToDataUri, m as blobToUint8Array, dG as browserSelectColorByName, cH as cloneJsonObject, cG as cloneObject, cb as cmp, ca as composeOrderby, _ as createArray, j as createBinaryStreamDecoder, i as createBinaryStreamEncoder, dS as createLocalChannelPair, d9 as createPromise, ea as createPromiseProxy, w as csvParse, x as csvParseToObjects, v as csvStringify, aM as dataUriToBlob, aL as dataUriToMimeType, aK as dataUriToUint8Array, bg as dateStringToDays, bf as day, aU as dayDay, b8 as dayDiff, aY as dayFromAny, a_ as dayFromDate, a$ as dayFromDateGMT, b3 as dayFromParts, b4 as dayFromString, b1 as dayFromTimestamp, aX as dayFromToday, ba as dayIterator, aT as dayMonth, b5 as dayMonthStart, b7 as dayOffset, b9 as dayRange, aW as dayToDate, aZ as dayToDateGMT, aV as dayToParts, b2 as dayToString, b0 as dayToTimestamp, aS as dayYear, b6 as dayYearStart, dn as debounce, cO as deburr, bj as decimal, bm as decimalCentsPart, bk as decimalFromCents, bl as decimalToCents, a4 as decodeBase16, a2 as decodeBase32, a6 as decodeBase58, a8 as decodeBase62, h as decodeJson, u as decrypt, bn as deepEqual, bp as deepMerge, bo as deepStripUndefinedInPlace, s as deriveKeyPbkdf2, ey as detect, bs as diffObjects, q as digest, eH as duration, cF as empty, a3 as encodeBase16, a1 as encodeBase32, a5 as encodeBase58, a7 as encodeBase62, g as encodeJson, cy as encodeQuery, t as encrypt, cs as endSortWeight, cA as ensureKey, cB as ensureKeyAsync, an as equalBinary, bt as escapeHTML, ce as escapeRegExp, a9 as estimateSizeForBase, f as fatal, ep as fetchBasic, eq as fetchJson, eu as fetchOptionsBasicAuth, es as fetchOptionsFormURLEncoded, et as fetchOptionsJson, er as fetchText, cD as first, aJ as fixBrokenUth8String, bd as forEachDay, cK as forTimes, aH as formatMessages, eE as formatMilliseconds, al as fromBase64, am as fromBase64String, au as fromCamelCase, ai as fromHex, ex as getGlobal, dp as getGlobalContext, dY as getGlobalEmitter, dr as getGlobalLogger, ds as getGlobalLoggerIfExists, dJ as getNamespaceFilterString, ew as getNavigator, eG as getPerformanceTimestamp, bX as getSecureRandom, bY as getSecureRandomIfPossible, eD as getTimestamp, ev as getWindow, en as httpMethod, db as immediate, by as isArray, bF as isBoolean, ez as isBrowser, bK as isEmpty, ch as isEven, cg as isHalf, bD as isInteger, dq as isLocalHost, bL as isNotEmpty, bJ as isNotNull, bH as isNull, bG as isNullOrUndefined, bC as isNumber, bw as isObject, c4 as isPrime, c3 as isPrimeRX, bx as isPrimitive, dg as isPromise, bz as isRecord, bA as isRecordPlain, bE as isSafeInteger, bB as isString, dd as isTimeout, bN as isTruthy, bI as isUint8Array, bM as isValue, dN as joinLogStrings, ag as joinToUint8Array, bQ as jsonStringify, bP as jsonStringifySafe, bO as jsonStringifySorted, ao as jsonToUint8Array, cE as last, dZ as lazyListener, cw as linkifyPlainText, bV as listDistinctUnion, bU as listGroupBy, bW as listOfKey, bT as listQuery, cI as memoize, cJ as memoizeAsync, ct as moveSortWeight, eJ as noop, c8 as objectIsEmpty, c6 as objectMap, c7 as objectMergeDisposable, eo as parseBasicAuth, eF as parseDate, dL as parseLogLevel, c9 as parseOrderby, cz as parseQuery, dh as promisify, f3 as qid, bZ as randomBoolean, b$ as randomFloat, b_ as randomInt, r as randomUint8Array, cM as regExpEscape, cL as regExpString, aI as renderMessages, cj as roundDown, cm as roundHalfAwayFromZero, cn as roundHalfDown, co as roundHalfEven, cl as roundHalfOdd, cp as roundHalfTowardsZero, ck as roundHalfUp, ci as roundUp, c5 as seededRandom, eZ as setUuidDefaultEncoding, cC as size, da as sleep, cu as sortedItems, cc as sortedOrderby, cr as startSortWeight, av as stringToBoolean, ax as stringToFloat, aw as stringToInteger, ad as stringToUInt8Array, eV as suid, eU as suidBytes, eX as suidBytesDate, eW as suidDate, c1 as sum, dm as throttle, dc as timeout, aj as toBase64, ak as toBase64Url, aF as toBool, ar as toCamelCase, as as toCapitalize, at as toCapitalizeWords, aC as toFloat, ah as toHex, cx as toHumanReadableUrl, aD as toInt, aE as toString, af as toUint8Array, cd as toValidFilename, be as today, de as tryTimeout, f2 as uname, bu as unescapeHTML, d0 as useAsyncMutex, a0 as useBase, cR as useDefer, cP as useDispose, cY as useEventListener, eA as useExitHandler, cW as useInterval, cX as useIntervalPause, dM as useLevelFilter, eb as useMessageHub, c$ as useMutex, dK as useNamespaceFilter, d7 as usePool, ed as usePubSub, ek as useRPC, el as useRPCHub, cv as useSorted, cV as useTimeout, e_ as uuid, eY as uuid32bit, eO as uuidB32, eL as uuidB62, eK as uuidBytes, e$ as uuidDecode, eQ as uuidDecodeB32, eN as uuidDecodeB62, eT as uuidDecodeV4, f0 as uuidEncode, eP as uuidEncodeB32, eM as uuidEncodeB62, eS as uuidEncodeV4, f1 as uuidIsValid, eR as uuidv4, ay as valueToBoolean, aA as valueToFloat, az as valueToInteger, aB as valueToString, df as waitOn } from './uuid-7feee97a.js';
import * as fs from 'fs';
import { Buffer } from 'node:buffer';

interface ParseConfig {
    args?: string[];
    alias?: Record<string, string[]>;
    normalize?: (value: string) => string;
    booleanArgs?: string | string[];
    listArgs?: string | string[];
    numberArgs?: string | string[];
}
declare function parseArgs(config?: ParseConfig): Record<string, any>;

/** Copy string to clipboard */
declare function pbcopy(data: string): Promise<unknown>;

declare function setupWebCrypto(): void;
declare function getWebCrypto(): Promise<Crypto>;

interface EnvOptions {
    /** @deprecated will probably be replaced by logLevel */
    debug?: boolean;
    path?: string;
    filename?: string;
    encoding?: BufferEncoding;
    prefix?: string;
    env?: Record<string, string>;
    mode?: string;
}
/**
 * Return a path relative to the current working directory
 */
declare function stringToPath(value?: string, defaultValue?: string): string;
declare function valueToPath(value?: any, defaultValue?: string): string;
declare const toPath: typeof valueToPath;
declare function getEnvVariableRelaxed(name: string, env?: NodeJS.ProcessEnv): string | undefined;
/** Populates process.env from .env file. */
declare function setupEnv(options?: EnvOptions): {
    parsed: Record<string, string>;
    error?: undefined;
} | {
    error: unknown;
    parsed?: undefined;
};

declare function getStat(path: string): fs.Stats | undefined;
declare function getFingerprint(path: string): string;
declare function walkSync(rootFolder: string, subFolder?: string, ignoreHidden?: boolean): string[];
declare function files(opt?: {
    basePath?: string;
    pattern?: string | RegExp;
    filter?: (name: string) => boolean;
    ignoreHidden?: boolean;
}): string[];

declare function getStatAsync(path: string): Promise<fs.Stats | undefined>;
declare function getFingerprintAsync(path: string): Promise<string>;
declare function walkSyncAsync(rootFolder: string, subFolder?: string, ignoreHidden?: boolean): Promise<string[]>;
declare function filesAsync(opt?: {
    basePath?: string;
    pattern?: string | RegExp;
    filter?: (name: string) => boolean;
    ignoreHidden?: boolean;
}): Promise<string[]>;

interface FileStorageOptions {
    pretty?: boolean;
    path?: string;
    extension?: string;
    objectFromString?: (data: string) => any;
    objectToString?: (data: any) => string;
    keyToFilename?: (key: string) => string;
}
declare class FileStorage<T = Json> implements ObjectStorage<T> {
    private store;
    private dirname;
    private fileKeys?;
    private pretty;
    private extension;
    private extensionLength;
    private objectFromString;
    private objectToString;
    private keyToFilename;
    constructor(opt?: FileStorageOptions);
    setItem(key: string, value: T): void;
    getPath(key: string): string;
    getBuffer(key: string): Buffer;
    getItem(key: string): T | undefined;
    removeItem(key: string): void;
    clear(): void;
    allKeys(): string[];
}

declare function toHumanReadableFilePath(path: string): string;
declare function exists(path: string): Promise<boolean>;
declare function isHiddenPath(path: string): boolean;
declare function ensureFolder(...parts: string[]): Promise<string>;
declare function removeFolder(...parts: string[]): Promise<string>;
declare function readText(...parts: string[]): Promise<string | undefined>;
declare function writeText(path: string, content: string): Promise<void>;

declare function globToRegExp(glob: string, opts?: any): RegExp;

declare function LoggerFileHandler(path: string, opt?: LogHandlerOptions): (msg: LogMessage) => void;

declare function colorString(text: string, colorCode: number): string;
declare function colorStringList(list: Array<any>, style: string, bold?: boolean): any[];
declare const loggerStackTraceDebug = "loggerStackTraceDebug-7d38e5a9214b58d29734374cdb9521fd964d7485";
declare function LoggerNodeHandler(opt?: LogHandlerOptions): LogHandler;

declare function getStackLlocationList(stack: string): string[];
/**
 * Get the source code location of the caller
 * https://stackoverflow.com/a/47296370/140927
 *
 * @param level Number of levels to go down the stack trace
 * @param stripCwd Strip the current working directory, only reasonable for Node.js environment
 */
declare function getSourceLocation(level?: number, stripCwd?: boolean): string;
declare function getStack(): string;
declare function getSourceLocationByPrecedingPattern(patterns: string[], stripCwd?: boolean): string;

declare function Logger(name?: string, level?: LogLevelAliasType): LoggerInterface;

export { FileStorage, FileStorageOptions, Json, LogHandler, LogHandlerOptions, LogLevelAliasType, LogMessage, Logger, LoggerFileHandler, LoggerInterface, LoggerNodeHandler, ObjectStorage, colorString, colorStringList, ensureFolder, exists, files, filesAsync, getEnvVariableRelaxed, getFingerprint, getFingerprintAsync, getSourceLocation, getSourceLocationByPrecedingPattern, getStack, getStackLlocationList, getStat, getStatAsync, getWebCrypto, globToRegExp, isHiddenPath, loggerStackTraceDebug, parseArgs, pbcopy, readText, removeFolder, setupEnv, setupWebCrypto, stringToPath, toHumanReadableFilePath, toPath, valueToPath, walkSync, walkSyncAsync, writeText };
